 
 #define Version "2021-0807"
 // 13/9/2014
 // tested on my IrdA board Microchip with LCD , but LCD not wired at same pins
 // CONFIG : $2007 : 0x3B3A
 
 
#define LCD_Used
// #define  Q4Mhz

#define CLS 12
#define CR 13
#define LF 10
#define BS 8
#define TAB 9

float chiffre_decimal, sec;
char texte[64], *pt;
unsigned char CRam1[32];
unsigned char *pointeur_de_char;
char txt[13];



#ifdef LCD_Used
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_RS at RB2_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
#endif


 // specifi to this IRDaBoard !
sbit sw1 at RA5_bit ;       // Switch2 avec rappel au +5V
//#define SW3 PORTA.RA4      // Switch1 avec rappel au +5V
sbit Reset_MCP2150 at RC0_bit ;
sbit LCD_PWR       at RD5_bit ;    // to power on the LCD
sbit LCD_PWR_dir  at TRISD.B5;     // to power on the LCD
//#define SW2 PORTA.RA5        // Switch2 avec rappel au +5V
//#define SW3 PORTA.RA4        // Switch1 avec rappel au +5V
sbit SW2 at PORTA.B5 ;       // Switch2 avec rappel au +5V
sbit SW3 at PORTA.B4 ;       // Switch1 avec rappel au +5V
sbit SW2_direction at TRISA5_bit;
sbit SW3_direction at TRISA.B4;

#define   Led_Verte_D0 RD0_bit
#define   Led_Verte_D1 RD1_bit
#define   Led_Verte_D2 RD2_bit
#define   Led_Verte_D3 RD3_bit
#define   Led_Verte_D4 RD4_bit
#define   Led_Verte_D5 RD5_bit
#define   Led_Verte_D6 RD6_bit
#define   Led_Verte_D7 RD7_bit



void StrConstRamCpy(unsigned char *dest, const code char *source) // Copie le texte de la FLASH ROM vers la RAM.
{
while (*source)*dest ++ = *source ++;
*dest = 0;                                                       // Terminateur "0" fin de chaine de caractre.
}


void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

void CRLF1()
 { UART1_Write(13);
  UART1_Write(10);
  }


void float_to_ASCII_with_2_decimal_v7(float fx, char *pt)
{
unsigned long e = 0;                                                 // 0 to 4294967295.
unsigned long d = 0;                                                 // 0 to 4294967295.
float chiffre_decimal = 0.000;

if (fx < 0)
    {
     *(pt) = '-';
     chiffre_decimal = - fx;
    }
    else
       {
        *(pt) = '+';
        chiffre_decimal = fx;
       }

e = (unsigned long) floor(chiffre_decimal);                          // Partie entire.
d = (chiffre_decimal - (float)e) * 100;                              // Partie dcimale (2 chiffres).
// fenetre ZERO !
if ((fx>-0.005) && (fx<0.005))
{
  e=0;
  d=0;
}

*(pt + 1) = ' ';              // Keep a space between sign and first digit.

if (e/1000000 >= 0) *(pt + 2) = (unsigned char) (e/1000000) + 0x30;  // Partie entire de 9999999  0.
e = e%1000000;
if (e/100000 >= 0) *(pt + 3) = (unsigned char) (e/100000) + 0x30;
e = e%100000;
if (e/10000 >= 0) *(pt + 4) = (unsigned char) (e/10000) + 0x30;
e = e%10000;
if (e/1000 >= 0) *(pt + 5) = (unsigned char) (e/1000) + 0x30;
e = e%1000;
if (e/100 >= 0) *(pt + 6) = (unsigned char) (e/100) + 0x30;
e = e%100;
if (e/10 >= 0) *(pt + 7) = (unsigned char) (e/10) + 0x30;
*(pt + 8) = (unsigned char) (e%10) + 0x30;
*(pt + 9) = 0x2C;                                                    // Virgule au lieu d'un point.
*(pt + 10) = (unsigned char) (d/10) + 0x30;                          // Partie dcimale de 00  99.
*(pt + 11) = (unsigned char) (d%10) + 0x30;
*(pt + 12) = 0;

if (*(pt + 2) == '0')                                                // Suppression des zros inutiles.
    {
     *(pt + 2) = ' ';
     if (*(pt + 3) == '0')
        {
         *(pt + 3) = ' ';
         if (*(pt + 4) == '0')
            {
             *(pt + 4) = ' ';
             if (*(pt + 5) == '0')
                {
                 *(pt + 5) = ' ';
                 if (*(pt + 6) == '0')
                    {
                     *(pt + 6) = ' ';
                     if (*(pt + 7) == '0')
                        {
                         *(pt + 7) = ' ';
                        }
                    }
                }
            }
        }
    }
}

void PRINT(void)
{
      float_to_ASCII_with_2_decimal_v7(sec, txt);
     Lcd_Out(2, 0, txt);   // Write txt in 2nd row, starting at 1st digit.
     StrConstRamCpy(pointeur_de_char, "S");
     UART1_Write_Text(txt);CRLF1();
     Lcd_Out(2, 13,txt);  // Write "uS" in 2nd row, starting at 14th digit
 }


void main()   
{

Delay_ms(500);
TRISA=0b11111111;   // if RA4 used as input
ADCON1=0b10001110;
ADCON0 = 0b01000000;     // FOSC/8 ch0
TRISB  = 0b00000001; //if  RB0 used as input
TRISC  = 0xFF;
PORTC.RC6=0;
PORTC.RC7=1;
TRISD=0b00000000 ;
LCD_PWR_dir=0;

PORTD=0;

 pointeur_de_char = &texte[0];
 Led_Verte_D7=1;
 Reset_MCP2150=0;   // reset MCP2150  specific to this IRDAboard to use UART1!
 Delay_ms(100);

 // LCD not used here, because can not change hardware LCD wiring  ,soldered !
   // Initialize LCD
 LCD_PWR=1;   // RD5 =LCD_PWR voir schema 103-00032 en C2
 Lcd_Init();
 Delay_ms(500);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);
  StrConstRamCpy(pointeur_de_char, "16F877 IRDA ");    // OK.
  Lcd_Out(1, 0, pointeur_de_char);
   Delay_ms(1500);

  UART1_Init(19200);
 Delay_ms(100);
  UART1_Write(CLS); // erase display on terminal VBRAY
  Delay_ms(500);
  CRLF1();
  

  StrConstRamCpy(pointeur_de_char, "Counting ...");    // OK.
  Lcd_Out(1, 0, pointeur_de_char);
  sec = -9999998.00;
  PRINT();
  sec = 0.05;
  PRINT();
  sec =9999998.00;
  PRINT();
  CRLF1();
  
   for(sec = -9.99;sec <= 9.99; sec = sec + 0.01)  PRINT();
   CRLF1();

 //Led_Verte_D7=0;   //   specific to this IRDAboard
 for(sec = -9999998.05;sec <= 9999998.05; sec = sec + 10000.05)     // sec dclare en float. FAIL.
     {
    //  portc.b2 = 1;                                        // LED yellow ON.
      PRINT();
      Delay_ms(5);
     }
}